SystemOrganization addCategory: #TpTraitsAlpha!

Trait named: #TAlumno
	uses: {}
	category: 'TpTraitsAlpha'!

!TAlumno methodsFor: 'as yet unclassified' stamp: 'PabloM 9/25/2013 23:12'!
anotarseEn:unCurso
	|cursada|
	cursada := unCurso nuevaCursada.
	cursada alumno: self .
	^cursada ! !

Trait named: #TCapacidad
	uses: {}
	category: 'TpTraitsAlpha'!

!TCapacidad methodsFor: 'as yet unclassified' stamp: 'PabloM 9/22/2013 22:54'!
capacidad
	self requirements ! !

!TCapacidad methodsFor: 'as yet unclassified' stamp: 'PabloM 9/22/2013 23:51'!
tieneCapacidadPara: unAula 
	"tanto charla/curso/seminario tienen que usar este trait y redefinir el metodo Capacidad, cada uno con su implementacion para traer a las personas que participan
	luego comparo las capacidades para saber si entran todas las personas "
	^ self capacidad >= unAula capacidad.! !

Trait named: #TConCorteDeTiempo
	uses: {}
	category: 'TpTraitsAlpha'!

!TConCorteDeTiempo methodsFor: 'as yet unclassified' stamp: 'PabloM 9/27/2013 21:45'!
crearCorteParaAo:unAnio
|corte|
corte := self .
corte cursadas: (self cursadas select: [:unaCursada | unaCursada curso perteneceAlAnio: unAnio]).
^ corte.
"|unCorteDeTiempo|
unCorteDeTiempo = ACorteDeTiempo new.
unCorteDeTiempo cursadas: (self cursadas select: [:unaCursada| unaCursada  perteneceAlAnio: unAo]).
^unCorteDeTiempo "! !

!TConCorteDeTiempo methodsFor: 'as yet unclassified' stamp: 'PabloM 9/27/2013 21:36'!
cursadas: cursadas 
	self requirements ! !

Trait named: #TConEventos
	uses: {}
	category: 'TpTraitsAlpha'!

!TConEventos methodsFor: 'as yet unclassified' stamp: 'Javi 9/25/2013 02:47'!
eventos
self requirements ! !

!TConEventos methodsFor: 'as yet unclassified' stamp: 'Javi 9/25/2013 02:48'!
informacionAgenda 
^self eventos collect: [:unEvento | unEvento informacionAgenda]! !

Trait named: #TCumplible
	uses: {}
	category: 'TpTraitsAlpha'!

!TCumplible methodsFor: 'as yet unclassified' stamp: 'PabloM 9/22/2013 23:52'!
loCumple: unAula
	"para asegurarme de que implementen loCumple un Pizarron y un Elemento asi los trato de forma polimorfica "
	self requirements .! !

Trait named: #TCursada
	uses: {}
	category: 'TpTraitsAlpha'!

!TCursada methodsFor: 'as yet unclassified' stamp: 'PabloM 9/25/2013 23:03'!
aniadirCursada: algoConCursadas. 
	algoConCursadas cursadas add: self .! !

Trait named: #TCurso
	uses: {}
	category: 'TpTraitsAlpha'!

!TCurso methodsFor: 'as yet unclassified' stamp: 'PabloM 9/26/2013 01:13'!
aniadirDocente:unDocente
	self docentes add: unDocente .
	unDocente cursos add: self .! !

!TCurso methodsFor: 'as yet unclassified' stamp: 'PabloM 9/25/2013 22:53'!
nuevaCursada
	|cursada|.
	cursada := ACursada new.
	cursada curso: self .
	^ cursada .! !

Trait named: #TDisponibilidad
	uses: {}
	category: 'TpTraitsAlpha'!

!TDisponibilidad methodsFor: 'as yet unclassified' stamp: 'PabloM 9/27/2013 10:12'!
disponible: unaFechaCurso
	"me fijo si la unaFecha esta disponible en base a los usos "
	^ self usos anySatisfy: [ :unaF | unaF contieneA: unaFechaCurso  ]! !

!TDisponibilidad methodsFor: 'as yet unclassified' stamp: 'PabloM 9/22/2013 23:56'!
estaDisponibleEnLasFechasDe: fechas
	"fechas seria una lista de fechas con elementos casi iguales a la Clase Sesion(la diferencia es que no tengo nombre aca)
	la idea seria que tenga la lista de las fechas qeu se va usar el aula 
	y despues preguntarle si para el aula, todas las fechas las tiene libres
	en el Caso de la charla que solo tienen un dia tendria que pasarle una lista con la unica fecha que tiene
	"
	^ fechas anySatisfy:  [:unaFecha | self disponible: unaFecha]! !

!TDisponibilidad methodsFor: 'as yet unclassified' stamp: 'PabloM 9/22/2013 23:58'!
usos
	"aca es donde guardaria las fechas en las que esta siendo usada"
	self requirements ! !

Trait named: #TEstadisticas
	uses: {}
	category: 'TpTraitsAlpha'!

!TEstadisticas methodsFor: 'as yet unclassified' stamp: 'Javi 9/20/2013 16:53'!
cantidadDeAbandonadas 
^self cursadas count: [:unaCursada| unaCursada fueAbandonada]! !

!TEstadisticas methodsFor: 'as yet unclassified' stamp: 'Javi 9/20/2013 16:52'!
cantidadDeAprobadas 
^self notas count: [:unaNota| unaNota >= 4]! !

!TEstadisticas methodsFor: 'as yet unclassified' stamp: 'PabloM 9/25/2013 19:02'!
cantidadDeIniciadas 
	^ self cursadas size ! !

!TEstadisticas methodsFor: 'as yet unclassified' stamp: 'PabloM 9/25/2013 20:06'!
cursadas
	self requirements ! !

!TEstadisticas methodsFor: 'as yet unclassified' stamp: 'PabloM 9/25/2013 19:16'!
cursadasTerminadas
	"traigo solo las que no abandono"
	^ self cursadas select: [: unaCursada | unaCursada fueAbandonada  not]! !

!TEstadisticas methodsFor: 'as yet unclassified' stamp: 'Javi 9/20/2013 17:24'!
notaMasAltaAlcanzadaNVeces: n
"Selecciono todas las notas alcanzadas n veces, y devuelvo la mas alta"
^#(1 2 3 4 5 6 7 8 9 10) select: [:unaNota | (self notas occurrencesOf: unaNota >= n)] max.! !

!TEstadisticas methodsFor: 'as yet unclassified' stamp: 'PabloM 9/25/2013 19:14'!
notas 
"^ self cursadas collect: [:cursada | cursada nota] "
^ self cursadasTerminadas  collect: [:cursada | cursada nota] ! !

!TEstadisticas methodsFor: 'as yet unclassified' stamp: 'Javi 9/20/2013 17:17'!
notasAprobadas 
^self notas select: [:unaNota | unaNota >= 4]! !

!TEstadisticas methodsFor: 'as yet unclassified' stamp: 'PabloM 9/25/2013 19:36'!
porcentajeDeAprobadosSobreIniciados 
"	^ self cantidadDeAprobadas / self cantidadDeIniciadas roundTo:0.01"
	^ (self cantidadDeAprobadas * 100 / self cantidadDeIniciadas ) roundTo:0.01! !

!TEstadisticas methodsFor: 'as yet unclassified' stamp: 'PabloM 9/25/2013 20:00'!
promedioConAplazos 
^self notas average roundTo: 0.01! !

!TEstadisticas methodsFor: 'as yet unclassified' stamp: 'PabloM 9/25/2013 20:00'!
promedioSinAplazos
^self notasAprobadas average roundTo: 0.01! !

!TEstadisticas methodsFor: 'as yet unclassified' stamp: 'Javi 9/20/2013 17:29'!
tablaDeNotas 
^#(1 2 3 4 5 6 7 8 9 10) collect: [:unaNota | self notas occurrencesOf: unaNota]! !

Trait named: #TEvento
	uses: {}
	category: 'TpTraitsAlpha'!

!TEvento methodsFor: 'as yet unclassified' stamp: 'Javi 9/25/2013 02:45'!
informacionAgenda
^(self fecha), ' ', (self horaDesde), ' ', (self horaHasta), ' ', (self string), String cr ! !

!TEvento methodsFor: 'as yet unclassified' stamp: 'Javi 9/25/2013 03:01'!
string
^self requirements ! !

Trait named: #TMateria
	uses: {}
	category: 'TpTraitsAlpha'!

!TMateria methodsFor: 'as yet unclassified' stamp: 'PabloM 9/25/2013 23:17'!
AbrirCurso
	|curso|
	curso := ACurso new.
	self cursos add: curso .
	^ curso .! !

Trait named: #TMulti
	uses: {}
	category: 'TpTraitsAlpha'!

!TMulti methodsFor: 'as yet unclassified' stamp: 'PabloM 9/25/2013 23:46'!
algoConCursadas 
	self requirements ! !

!TMulti methodsFor: 'as yet unclassified' stamp: 'PabloM 9/25/2013 23:51'!
cursadas
	^ (self algoConCursadas collect: [:unElemento| unElemento cursadas] )gather: [:e|e].! !

Trait named: #TMultiAlumno
	uses: TMulti
	category: 'TpTraitsAlpha'!

TMultiAlumno classTrait
	uses: TMulti classTrait!

!TMultiAlumno methodsFor: 'as yet unclassified' stamp: 'PabloM 9/25/2013 23:47'!
algoConCursadas 
	^  self alumnos.! !

!TMultiAlumno methodsFor: 'as yet unclassified' stamp: 'PabloM 9/25/2013 23:45'!
alumnos
	self requirements ! !

Trait named: #TMultiCurso
	uses: TMulti
	category: 'TpTraitsAlpha'!

TMultiCurso classTrait
	uses: TMulti classTrait!

!TMultiCurso methodsFor: 'as yet unclassified' stamp: 'PabloM 9/25/2013 23:48'!
algoConCursadas 
	^ self cursos.! !

!TMultiCurso methodsFor: 'as yet unclassified' stamp: 'PabloM 9/25/2013 23:45'!
cursos
	self requirements ! !

Trait named: #TMultiMateria
	uses: TMulti
	category: 'TpTraitsAlpha'!

TMultiMateria classTrait
	uses: TMulti classTrait!

!TMultiMateria methodsFor: 'as yet unclassified' stamp: 'PabloM 9/25/2013 23:48'!
algoConCursadas 
	^ self materias ! !

!TMultiMateria methodsFor: 'as yet unclassified' stamp: 'PabloM 9/25/2013 23:45'!
materias
	self requirements ! !

Trait named: #TRecursosCumplibles
	uses: {}
	category: 'TpTraitsAlpha'!

!TRecursosCumplibles methodsFor: 'as yet unclassified' stamp: 'PabloM 9/22/2013 23:59'!
cumpleConLosRecursos:unAula
	"aca me fijo  si el aula tiene todo los recursos que pide el Curso/Charla/Seminario"
	
	^ self recursos allSatisfy: [:unRecurso | unRecurso loCumple:  unAula ]! !

!TRecursosCumplibles methodsFor: 'as yet unclassified' stamp: 'PabloM 9/23/2013 00:00'!
recursos 
	"es una coleccion tanto de elementos(enchufes, proyectores etc ..) como de Pizarron (con la superficie)"
	"tengo qeu asegurarme de que tanto la Clase Elemento como Pizarron entiendan el mensaje loCumple:unAula"
	self requirements .! !

Trait named: #TTemporal
	uses: {}
	category: 'TpTraitsAlpha'!

!TTemporal methodsFor: 'as yet unclassified' stamp: 'PabloM 10/2/2013 19:55'!
contienA: otraFechaCurso
	^(self fechaDesde  <= (otraFechaCurso fechaDesde )) && (self fechaHasta  >= (otraFechaCurso  fechaHasta ))
		  && 
	  (self horaDesde <= (otraFechaCurso horaDesde)) && (self horaHasta >= (otraFechaCurso  horaHasta ))! !

!TTemporal methodsFor: 'as yet unclassified' stamp: 'PabloM 10/2/2013 20:19'!
fecha
	"si fechaDesde y fechaHasta son iguales devuelvo la fecha, sino devuelvo nil"
	(self fechaDesde == self fechaHasta ) ifTrue:  [^self fechaDesde ].
	^ nil.! !

!TTemporal methodsFor: 'as yet unclassified' stamp: 'PabloM 10/2/2013 20:03'!
fecha: unaFecha
"le pongo la fecha a desde y hasta"
	self requirements 
	! !

!TTemporal methodsFor: 'as yet unclassified' stamp: 'PabloM 10/2/2013 20:42'!
fechaCurso
	|fechaCurso|
	"hago una lista de un elemento"
	fechaCurso := FechaCurso  new.
	
	fechaCurso fechaDesde: self fechaDesde .
	fechaCurso fechaHasta: self fechaHasta .
	
	fechaCurso horaDesde: self horaDesde .
	fechaCurso horaHasta: self horaHasta.

	^ fechaCurso ! !

!TTemporal methodsFor: 'as yet unclassified' stamp: 'PabloM 10/2/2013 19:48'!
fechaDesde
	self requirements ! !

!TTemporal methodsFor: 'as yet unclassified' stamp: 'PabloM 10/2/2013 19:48'!
fechaHasta
	self requirements ! !

!TTemporal methodsFor: 'as yet unclassified' stamp: 'PabloM 10/2/2013 19:47'!
horaDesde
	self requirements ! !

!TTemporal methodsFor: 'as yet unclassified' stamp: 'PabloM 10/2/2013 19:48'!
horaHasta
	self requirements ! !

!TTemporal methodsFor: 'as yet unclassified' stamp: 'PabloM 9/27/2013 21:18'!
perteneceAlAnio: unAnio
	^ self fecha year ==unAnio ! !

Trait named: #Tservible
	uses: {}
	category: 'TpTraitsAlpha'!

!Tservible methodsFor: 'as yet unclassified' stamp: 'PabloM 10/2/2013 19:19'!
cantidadDePersonas
	self requirements ! !

!Tservible methodsFor: 'as yet unclassified' stamp: 'PabloM 10/2/2013 20:12'!
fechas 
	"es una lista de las fechas, lista de FechaCurso "
	self requirements ! !

!Tservible methodsFor: 'as yet unclassified' stamp: 'PabloM 10/2/2013 19:19'!
meSirve: unAula
	"aca pregunto por las tres condiciones que me dicen si un aula esta disponible para un Curso/Charla/Seminario
	1) que este disponible todas las fechas
	2) que entren todas las personas
	3) que tenga todos los recursos que necesita
	"
	^ (unAula estaDisponibleEnLasFechasDe: self fechas) && (unAula tieneCapacidadPara: self cantidadDePersonas ) && (unAula cumpleConLosRecursos: self recursos) .! !

!Tservible methodsFor: 'as yet unclassified' stamp: 'PabloM 10/2/2013 19:22'!
recursos 
	self requirements ! !

Object subclass: #AActividad
	instanceVariableNames: 'grupo responsable fechaPresentacion fechaAprobacion montoFinanciamiento nombre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraitsAlpha'!

!AActividad methodsFor: 'as yet unclassified' stamp: 'Javi 9/25/2013 03:08'!
articulosConFecha ! !

!AActividad methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:28'!
fechaAprobacion
	^ fechaAprobacion! !

!AActividad methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:28'!
fechaAprobacion: anObject
	fechaAprobacion := anObject! !

!AActividad methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:28'!
fechaPresentacion
	^ fechaPresentacion! !

!AActividad methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:28'!
fechaPresentacion: anObject
	fechaPresentacion := anObject! !

!AActividad methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:29'!
grupo
	^ grupo! !

!AActividad methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:29'!
grupo: anObject
	grupo := anObject! !

!AActividad methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:52'!
informacionAgenda! !

!AActividad methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:28'!
montoFinanciamiento
	^ montoFinanciamiento! !

!AActividad methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:28'!
montoFinanciamiento: anObject
	montoFinanciamiento := anObject! !

!AActividad methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:28'!
nombre
	^ nombre! !

!AActividad methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:28'!
nombre: anObject
	nombre := anObject! !

!AActividad methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:28'!
responsable
	^ responsable! !

!AActividad methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:28'!
responsable: anObject
	responsable := anObject! !

AActividad subclass: #ACharla
	uses: TEvento + Tservible + TTemporal
	instanceVariableNames: 'cantidadEstimadaPublico fechaDesde fechaHasta horaDesde horaHasta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraitsAlpha'!

ACharla class
	uses: TEvento classTrait + Tservible classTrait + TTemporal classTrait
	instanceVariableNames: ''!

!ACharla methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:32'!
cantidadEstimadaPublico
	^ cantidadEstimadaPublico! !

!ACharla methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:32'!
cantidadEstimadaPublico: anObject
	cantidadEstimadaPublico := anObject! !

!ACharla methodsFor: 'as yet unclassified' stamp: 'PabloM 10/2/2013 20:05'!
fecha: unaFecha
"le pongo la fecha a desde y hasta"
	self fechaDesde: unaFecha .
	self fechaHasta: unaFecha .
	! !

!ACharla methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:02'!
fechaDesde
	^ fechaDesde! !

!ACharla methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:02'!
fechaDesde: anObject
	fechaDesde := anObject! !

!ACharla methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:02'!
fechaHasta
	^ fechaHasta! !

!ACharla methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:02'!
fechaHasta: anObject
	fechaHasta := anObject! !

!ACharla methodsFor: 'as yet unclassified' stamp: 'PabloM 10/2/2013 20:43'!
fechas 
	"es una lista de las fechas, lista de FechaCurso "
	|fechas |
	"hago una lista de un elemento"

	fechas := Bag new.
	fechas add: self fechaCurso .
! !

!ACharla methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:32'!
horaDesde
	^ horaDesde! !

!ACharla methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:32'!
horaDesde: anObject
	horaDesde := anObject! !

!ACharla methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:32'!
horaHasta
	^ horaHasta! !

!ACharla methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:32'!
horaHasta: anObject
	horaHasta := anObject! !

!ACharla methodsFor: 'as yet unclassified' stamp: 'Javi 9/25/2013 03:02'!
string
^self nombre  ! !

AActividad subclass: #AProyecto
	uses: TConEventos
	instanceVariableNames: 'experimentos resultados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraitsAlpha'!

AProyecto class
	uses: TConEventos classTrait
	instanceVariableNames: ''!

!AProyecto methodsFor: 'as yet unclassified' stamp: 'Javi 9/25/2013 03:19'!
articulos 
^self resultados select: [:unResultado | unResultado esArticulo]! !

!AProyecto methodsFor: 'as yet unclassified' stamp: 'Javi 9/25/2013 03:18'!
articulosConFecha 
^self articulos collect: [:unArticulo | unArticulo descripcion, ' ', unArticulo fecha asString]! !

!AProyecto methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:53'!
eventos
^experimentos ! !

!AProyecto methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:32'!
experimentos
	^ experimentos! !

!AProyecto methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:32'!
experimentos: anObject
	experimentos := anObject! !

!AProyecto methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:32'!
resultados
	^ resultados! !

!AProyecto methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:32'!
resultados: anObject
	resultados := anObject! !

AActividad subclass: #ASeminario
	uses: TConEventos + Tservible
	instanceVariableNames: 'sesiones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraitsAlpha'!

ASeminario class
	uses: TConEventos classTrait + Tservible classTrait
	instanceVariableNames: ''!

!ASeminario methodsFor: 'as yet unclassified' stamp: 'Javi 9/25/2013 02:59'!
aadirSesionEnFecha: unaFecha horaDesde: unaHoraDesde horaHasta: unaHoraHasta
|nuevaSesion|
nuevaSesion := ASesion new.
nuevaSesion fecha: unaFecha.
nuevaSesion horaDesde: unaHoraDesde.
nuevaSesion horaHasta: unaHoraHasta.
nuevaSesion seminario: self.
sesiones add: nuevaSesion.
^nuevaSesion ! !

!ASeminario methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:53'!
eventos
^sesiones! !

!ASeminario methodsFor: 'as yet unclassified' stamp: 'PabloM 10/2/2013 20:44'!
fechas 
	"es una lista de las fechas, lista de FechaCurso "
	|fechas fechaCurso|
		
	^ sesiones collect: [:unaSesion | unaSesion fechaCurso ]
	
	
	
	
! !

!ASeminario methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:30'!
sesiones
	^ sesiones! !

!ASeminario methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:30'!
sesiones: anObject
	sesiones := anObject! !

Object subclass: #ACarrera
	uses: TEstadisticas - {#cursadas} + TMultiAlumno
	instanceVariableNames: 'alumnos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraitsAlpha'!

ACarrera class
	uses: TEstadisticas classTrait + TMultiAlumno classTrait
	instanceVariableNames: ''!

!ACarrera methodsFor: 'accessing' stamp: 'PabloM 9/25/2013 23:53'!
alumnos
	^ alumnos! !

!ACarrera methodsFor: 'accessing' stamp: 'PabloM 9/25/2013 23:53'!
alumnos: anObject
	alumnos := anObject! !

!ACarrera methodsFor: 'as yet unclassified' stamp: 'PabloM 9/27/2013 21:42'!
initialize 
	super initialize .
	alumnos := Set new.! !

Object subclass: #ACorteDeTiempo
	uses: TEstadisticas
	instanceVariableNames: 'cursadas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraitsAlpha'!

ACorteDeTiempo class
	uses: TEstadisticas classTrait
	instanceVariableNames: ''!

!ACorteDeTiempo methodsFor: 'accessing' stamp: 'Javi 9/20/2013 16:16'!
cursadas
	^ cursadas! !

!ACorteDeTiempo methodsFor: 'accessing' stamp: 'Javi 9/20/2013 16:16'!
cursadas: anObject
	cursadas := anObject! !

Object subclass: #ACursada
	uses: TCursada
	instanceVariableNames: 'nota alumno curso fecha abandonada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraitsAlpha'!

ACursada class
	uses: TCursada classTrait
	instanceVariableNames: ''!

!ACursada class methodsFor: 'as yet unclassified' stamp: 'Javi 9/20/2013 17:41'!
crearCursadaParaAlumno: unAlumno fecha: unaFecha curso: unCurso
|unaCursada|
unaCursada := self new.
unaCursada alumno: unAlumno.
unaCursada fecha: unaFecha.
unaCursada curso: unCurso.
unAlumno aniadirCursada: unaCursada.
unCurso aniadirCursada: unaCursada.
^unaCursada.

! !

!ACursada methodsFor: 'accessing' stamp: 'Javi 9/20/2013 16:25'!
alumno
	^ alumno! !

!ACursada methodsFor: 'accessing' stamp: 'PabloM 9/25/2013 23:03'!
alumno: unAlumno
	alumno := unAlumno.
"cuando agrego un alumno agrego la cursada al alumno"
"	unAlumno aniadirCursada: self ."
	self aniadirCursada: unAlumno .

	
	! !

!ACursada methodsFor: 'as yet unclassified' stamp: 'PabloM 9/25/2013 23:06'!
aniadirCursada: algoConCursadas. 
	"agrego a su lista de cursadas yo mismo para que ambas se referencien"
	algoConCursadas cursadas add: self .! !

!ACursada methodsFor: 'accessing' stamp: 'Javi 9/20/2013 16:25'!
curso
	^ curso! !

!ACursada methodsFor: 'accessing' stamp: 'PabloM 9/25/2013 23:03'!
curso: unCurso
	curso := unCurso.
"	unCurso aniadirCursada: self ."
	self aniadirCursada: unCurso .! !

!ACursada methodsFor: 'accessing' stamp: 'Javi 9/20/2013 16:45'!
fecha
	^ fecha! !

!ACursada methodsFor: 'accessing' stamp: 'Javi 9/20/2013 16:45'!
fecha: anObject
	fecha := anObject! !

!ACursada methodsFor: 'accessing' stamp: 'Javi 9/20/2013 17:15'!
fueAbandonada
	^ abandonada! !

!ACursada methodsFor: 'accessing' stamp: 'Javi 9/20/2013 17:36'!
initialize
abandonada := false.
nota := nil.! !

!ACursada methodsFor: 'accessing' stamp: 'Javi 9/20/2013 16:25'!
nota
	^ nota! !

!ACursada methodsFor: 'accessing' stamp: 'Javi 9/20/2013 16:25'!
nota: anObject
	nota := anObject! !

!ACursada methodsFor: 'accessing' stamp: 'Javi 9/20/2013 17:15'!
setAbandonada
abandonada := true! !

Object subclass: #ACurso
	uses: TEstadisticas + TCurso + TTemporal + Tservible
	instanceVariableNames: 'cursadas docentes fechaDesde fechaHasta horaDesde horaHasta diaDeLaSemana'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraitsAlpha'!

ACurso class
	uses: TEstadisticas classTrait + TCurso classTrait + TTemporal classTrait + Tservible classTrait
	instanceVariableNames: ''!

!ACurso methodsFor: 'accessing' stamp: 'Javi 9/20/2013 16:26'!
cursadas
	^ cursadas! !

!ACurso methodsFor: 'accessing' stamp: 'Javi 9/20/2013 16:26'!
cursadas: anObject
	cursadas := anObject! !

!ACurso methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 21:17'!
diaDeLaSemana
	^ diaDeLaSemana! !

!ACurso methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 21:17'!
diaDeLaSemana: anObject
	diaDeLaSemana := anObject! !

!ACurso methodsFor: 'accessing' stamp: 'PabloM 9/26/2013 00:32'!
docentes
	^ docentes! !

!ACurso methodsFor: 'accessing' stamp: 'PabloM 9/26/2013 01:10'!
docentes: unDocente
	docentes := unDocente ! !

!ACurso methodsFor: 'as yet unclassified' stamp: 'PabloM 10/2/2013 20:25'!
fecha
	"si fechaDesde y fechaHasta son iguales devuelvo la fecha, sino devuelvo nil"
	(self fechaDesde year == self fechaHasta year  ) ifTrue:  [^self fechaDesde ].
	^ nil.! !

!ACurso methodsFor: 'as yet unclassified' stamp: 'PabloM 10/2/2013 20:04'!
fecha: unaFecha
"le pongo la fecha a desde y hasta"
	self fechaDesde: unaFecha .
	self fechaHasta: unaFecha .
	! !

!ACurso methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:00'!
fechaDesde
	^ fechaDesde! !

!ACurso methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:00'!
fechaDesde: anObject
	fechaDesde := anObject! !

!ACurso methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:00'!
fechaHasta
	^ fechaHasta! !

!ACurso methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:00'!
fechaHasta: anObject
	fechaHasta := anObject! !

!ACurso methodsFor: 'as yet unclassified' stamp: 'PabloM 10/2/2013 23:16'!
fechas 
	"es una lista de las fechas, lista de FechaCurso "
	|fechasDelCurso desde hasta fc diasAux|
	fechasDelCurso := Bag new.
		
	"obtengo la primer fechaCurso"
	
	diasAux :=  ( diaDeLaSemana >= self fechaDesde dayOfWeek ) 
								ifTrue: [diasAux :=diaDeLaSemana - (self fechaDesde dayOfWeek) ] 
								ifFalse: [diasAux := 7 - (self fechaDesde dayOfWeek) + diaDeLaSemana  ].
	desde := fechaDesde addDays:diasAux.
	
	fc:= desde.
	
	[fc <= self fechaHasta ] whileTrue: [fechasDelCurso add: (FechaCurso newConFecha: fc desde:  horaDesde hasta: horaHasta) . 
										fc :=fc addDays: 7].		

	^fechasDelCurso .! !

!ACurso methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:00'!
horaDesde
	^ horaDesde! !

!ACurso methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:00'!
horaDesde: anObject
	horaDesde := anObject! !

!ACurso methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:00'!
horaHasta
	^ horaHasta! !

!ACurso methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:00'!
horaHasta: anObject
	horaHasta := anObject! !

!ACurso methodsFor: 'as yet unclassified' stamp: 'PabloM 10/2/2013 20:26'!
initialize 
	super initialize .
	"cursadas := Set new."
	cursadas := Bag new.
	docentes := Bag new.
	
"	self fecha: Date today ."
	fechaDesde := Date today .
	fechaHasta  := Date today .
	horaDesde := nil.
	horaHasta  := nil.! !

!ACurso methodsFor: 'as yet unclassified' stamp: 'PabloM 10/2/2013 20:22'!
perteneceAlAnio: unAnio
	^ (self fecha) year ==unAnio ! !

Object subclass: #AExperimento
	uses: TEvento
	instanceVariableNames: 'fecha horaDesde horaHasta descripcion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraitsAlpha'!

AExperimento class
	uses: TEvento classTrait
	instanceVariableNames: ''!

!AExperimento methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:34'!
descripcion
	^ descripcion! !

!AExperimento methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:34'!
descripcion: anObject
	descripcion := anObject! !

!AExperimento methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:34'!
fecha
	^ fecha! !

!AExperimento methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:34'!
fecha: anObject
	fecha := anObject! !

!AExperimento methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:34'!
horaDesde
	^ horaDesde! !

!AExperimento methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:34'!
horaDesde: anObject
	horaDesde := anObject! !

!AExperimento methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:34'!
horaHasta
	^ horaHasta! !

!AExperimento methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:34'!
horaHasta: anObject
	horaHasta := anObject! !

!AExperimento methodsFor: 'as yet unclassified' stamp: 'Javi 9/25/2013 03:02'!
string
^self descripcion  ! !

Object subclass: #AGrupoInvestigacion
	instanceVariableNames: 'actividades integrantes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraitsAlpha'!

!AGrupoInvestigacion methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:29'!
actividades
	^ actividades! !

!AGrupoInvestigacion methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:29'!
actividades: anObject
	actividades := anObject! !

!AGrupoInvestigacion methodsFor: 'as yet unclassified' stamp: 'Javi 9/25/2013 03:05'!
actividadesPresentadasPeroNoAprobadas
^self actividades select: [:unaActividad | unaActividad fechaAprobacion isNil]! !

!AGrupoInvestigacion methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:51'!
agendaEventos
^(self actividades collect: [:unaActividad |unaActividad informacionAgenda]) gather: [:e|e]! !

!AGrupoInvestigacion methodsFor: 'as yet unclassified' stamp: 'Javi 9/25/2013 03:07'!
articulosConFecha
^(self actividades collect: [:unaActividad | unaActividad articulosConFecha]) gather: [:e|e]! !

!AGrupoInvestigacion methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:29'!
integrantes
	^ integrantes! !

!AGrupoInvestigacion methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:29'!
integrantes: anObject
	integrantes := anObject! !

!AGrupoInvestigacion methodsFor: 'as yet unclassified' stamp: 'Javi 9/25/2013 03:03'!
montoTotalDeFinanciamiento
^self actividades sum: [:unaActividad | unaActividad montoFinanciamiento]! !

Object subclass: #AMateria
	uses: TEstadisticas - {#cursadas} + TMateria + TMultiCurso
	instanceVariableNames: 'cursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraitsAlpha'!

AMateria class
	uses: TEstadisticas classTrait + TMateria classTrait + TMultiCurso classTrait
	instanceVariableNames: ''!

!AMateria methodsFor: 'accessing' stamp: 'Javi 9/20/2013 16:26'!
cursos
	^ cursos! !

!AMateria methodsFor: 'accessing' stamp: 'Javi 9/20/2013 16:26'!
cursos: anObject
	cursos := anObject! !

!AMateria methodsFor: 'as yet unclassified' stamp: 'PabloM 9/27/2013 21:42'!
initialize 
	super initialize .
	cursos  := Set new.! !

Object subclass: #APersona
	instanceVariableNames: 'gruposInvestigacion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraitsAlpha'!

APersona subclass: #AAlumno
	uses: TEstadisticas + TConCorteDeTiempo + TAlumno
	instanceVariableNames: 'cursadas carrera'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraitsAlpha'!

AAlumno class
	uses: TEstadisticas classTrait + TConCorteDeTiempo classTrait + TAlumno classTrait
	instanceVariableNames: ''!

!AAlumno methodsFor: 'accessing' stamp: 'PabloM 9/25/2013 23:14'!
carrera
	^ carrera! !

!AAlumno methodsFor: 'accessing' stamp: 'PabloM 9/25/2013 23:56'!
carrera: unaCarrera
	carrera := unaCarrera .
	unaCarrera alumnos add: self 


! !

!AAlumno methodsFor: 'accessing' stamp: 'Javi 9/20/2013 16:26'!
cursadas
	^ cursadas! !

!AAlumno methodsFor: 'accessing' stamp: 'Javi 9/20/2013 16:26'!
cursadas: anObject
	cursadas := anObject! !

!AAlumno methodsFor: 'as yet unclassified' stamp: 'PabloM 9/27/2013 21:42'!
initialize 
	super initialize .
"	cursadas := Set new."
	carrera := nil.
	cursadas := Set new.! !

APersona subclass: #ADocente
	uses: TEstadisticas - {#cursadas} + TConCorteDeTiempo + TMultiCurso
	instanceVariableNames: 'cursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraitsAlpha'!

ADocente class
	uses: TEstadisticas classTrait + TConCorteDeTiempo classTrait + TMultiCurso classTrait
	instanceVariableNames: ''!

!ADocente methodsFor: 'as yet unclassified' stamp: 'PabloM 9/27/2013 21:49'!
cursadas: cursadas 
	"tengo que transformar las cursadas en cursos"
	|cursosDeLasCursadas|
	cursosDeLasCursadas := Set new. "para que no agregue repetidos"
	cursadas do: [:unaCursada | cursosDeLasCursadas add: unaCursada curso ] .
	self cursos: cursosDeLasCursadas asBag .

	! !

!ADocente methodsFor: 'accessing' stamp: 'Javi 9/20/2013 16:26'!
cursos
	^ cursos! !

!ADocente methodsFor: 'accessing' stamp: 'Javi 9/20/2013 16:26'!
cursos: anObject
	cursos := anObject! !

!ADocente methodsFor: 'as yet unclassified' stamp: 'PabloM 9/27/2013 21:42'!
initialize 
	super initialize .
	cursos := Set new.! !

!APersona methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:35'!
gruposInvestigacion
	^ gruposInvestigacion! !

!APersona methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:35'!
gruposInvestigacion: anObject
	gruposInvestigacion := anObject! !

Object subclass: #AResultado
	instanceVariableNames: 'descripcion fecha'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraitsAlpha'!

!AResultado methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:33'!
descripcion
	^ descripcion! !

!AResultado methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:33'!
descripcion: anObject
	descripcion := anObject! !

!AResultado methodsFor: 'accessing' stamp: 'Javi 9/25/2013 03:20'!
esArticulo 
^descripcion includesSubString: 'artculo'! !

!AResultado methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:33'!
fecha
	^ fecha! !

!AResultado methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:33'!
fecha: anObject
	fecha := anObject! !

Object subclass: #ASesion
	uses: TEvento + TTemporal
	instanceVariableNames: 'fechaDesde fechaHasta horaDesde horaHasta seminario'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraitsAlpha'!

ASesion class
	uses: TEvento classTrait + TTemporal classTrait
	instanceVariableNames: ''!

!ASesion methodsFor: 'as yet unclassified' stamp: 'PabloM 10/2/2013 20:09'!
fecha: unaFecha
"le pongo la fecha a desde y hasta"
	self fechaDesde: unaFecha .
	self fechaHasta: unaFecha .
	! !

!ASesion methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:09'!
fechaDesde
	^ fechaDesde! !

!ASesion methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:09'!
fechaDesde: anObject
	fechaDesde := anObject! !

!ASesion methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:09'!
fechaHasta
	^ fechaHasta! !

!ASesion methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:09'!
fechaHasta: anObject
	fechaHasta := anObject! !

!ASesion methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:31'!
horaDesde
	^ horaDesde! !

!ASesion methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:31'!
horaDesde: anObject
	horaDesde := anObject! !

!ASesion methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:31'!
horaHasta
	^ horaHasta! !

!ASesion methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:31'!
horaHasta: anObject
	horaHasta := anObject! !

!ASesion methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:56'!
seminario
	^ seminario! !

!ASesion methodsFor: 'accessing' stamp: 'Javi 9/25/2013 02:56'!
seminario: anObject
	seminario := anObject! !

!ASesion methodsFor: 'as yet unclassified' stamp: 'Javi 9/25/2013 03:01'!
string
^self seminario nombre! !

Object subclass: #Aula
	uses: TDisponibilidad
	instanceVariableNames: 'usos elementos pizarron capacidad'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraitsAlpha'!

Aula class
	uses: TDisponibilidad classTrait
	instanceVariableNames: ''!

!Aula methodsFor: 'accessing' stamp: 'PabloM 9/22/2013 23:24'!
capacidad
	^ capacidad! !

!Aula methodsFor: 'accessing' stamp: 'PabloM 9/22/2013 23:24'!
capacidad: anObject
	capacidad := anObject! !

!Aula methodsFor: 'accessing' stamp: 'PabloM 9/22/2013 23:24'!
elementos
	^ elementos! !

!Aula methodsFor: 'accessing' stamp: 'PabloM 9/22/2013 23:24'!
elementos: anObject
	elementos := anObject! !

!Aula methodsFor: 'as yet unclassified' stamp: 'PabloM 9/22/2013 23:23'!
initialize 
	super initialize .
	pizarron := Pizarron new.
	pizarron superficie: 5.
	usos :=Bag new.
	capacidad :=10.
	! !

!Aula methodsFor: 'accessing' stamp: 'PabloM 9/22/2013 23:24'!
pizarron
	^ pizarron! !

!Aula methodsFor: 'accessing' stamp: 'PabloM 9/22/2013 23:24'!
pizarron: anObject
	pizarron := anObject! !

!Aula methodsFor: 'accessing' stamp: 'PabloM 9/22/2013 23:24'!
usos
	^ usos! !

!Aula methodsFor: 'accessing' stamp: 'PabloM 9/22/2013 23:24'!
usos: anObject
	usos := anObject! !

Object subclass: #Elemento
	uses: TCumplible
	instanceVariableNames: 'nombre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraitsAlpha'!

!Elemento commentStamp: '<historical>' prior: 0!
un elemento seria:
unEnchufe, 
unaZapatilla, 
unProyector, 
etc ...!

Elemento class
	uses: TCumplible classTrait
	instanceVariableNames: ''!

!Elemento methodsFor: 'as yet unclassified' stamp: 'PabloM 9/22/2013 23:47'!
initialize 
	"un elemento seria una zapatilla, proyector, enchufe, estufa etc ...
	usa el TCumplible para que pueda agregar tanto Elementos como Pizaron a la lista de Requerimienots para el Curso/Charla/Seminario"
	super initialize .
	nombre :=''.! !

!Elemento methodsFor: 'as yet unclassified' stamp: 'PabloM 9/22/2013 23:28'!
loCumple: unAula
	unAula elementos anySatisfy: [:unElemento | unElemento nombre == (self nombre)]! !

!Elemento methodsFor: 'accessing' stamp: 'PabloM 9/22/2013 23:28'!
nombre
	^ nombre! !

!Elemento methodsFor: 'accessing' stamp: 'PabloM 9/22/2013 23:28'!
nombre: anObject
	nombre := anObject! !

Object subclass: #FechaCurso
	uses: TTemporal
	instanceVariableNames: 'fechaDesde fechaHasta horaDesde horaHasta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraitsAlpha'!

FechaCurso class
	uses: TTemporal classTrait
	instanceVariableNames: ''!

!FechaCurso class methodsFor: 'as yet unclassified' stamp: 'PabloM 10/2/2013 22:00'!
newConFecha:unaFecha desde:horaDesde hasta:horaHasta
	|fc|
	fc := FechaCurso new.
	
	fc fecha:unaFecha.
	fc horaDesde:  horaDesde .
	fc horaHasta: horaHasta .	

	^ fc.! !

!FechaCurso methodsFor: 'as yet unclassified' stamp: 'PabloM 10/2/2013 21:59'!
fecha: unaFecha
"le pongo la fecha a desde y hasta"
	self fechaDesde: unaFecha .
	self fechaHasta: unaFecha 
	! !

!FechaCurso methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:14'!
fechaDesde
	^ fechaDesde! !

!FechaCurso methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:14'!
fechaDesde: anObject
	fechaDesde := anObject! !

!FechaCurso methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:14'!
fechaHasta
	^ fechaHasta! !

!FechaCurso methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:14'!
fechaHasta: anObject
	fechaHasta := anObject! !

!FechaCurso methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:14'!
horaDesde
	^ horaDesde! !

!FechaCurso methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:14'!
horaDesde: anObject
	horaDesde := anObject! !

!FechaCurso methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:14'!
horaHasta
	^ horaHasta! !

!FechaCurso methodsFor: 'accessing' stamp: 'PabloM 10/2/2013 20:14'!
horaHasta: anObject
	horaHasta := anObject! !

Object subclass: #Pizarron
	uses: TCumplible
	instanceVariableNames: 'superficie'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraitsAlpha'!

Pizarron class
	uses: TCumplible classTrait
	instanceVariableNames: ''!

!Pizarron methodsFor: 'as yet unclassified' stamp: 'PabloM 9/22/2013 23:48'!
initialize 
	"el pizarron seria para guardar la superficie del pizarron, usa el Trait TCumplible para implementar loCumple al igual que con los elementos
	y poder tratar tanto a los elementos como al pizarron de la misma forma, preguntando si loCumple:unAlula"
	super initialize .
	superficie := 0.! !

!Pizarron methodsFor: 'as yet unclassified' stamp: 'PabloM 9/22/2013 23:20'!
loCumple: unAula
	unAula superficieDelPizarron >= self superficie .! !

!Pizarron methodsFor: 'accessing' stamp: 'PabloM 9/22/2013 23:17'!
superficie
	^ superficie! !

!Pizarron methodsFor: 'accessing' stamp: 'PabloM 9/22/2013 23:17'!
superficie: anObject
	superficie := anObject! !
